Module java.base
Package java.nio.channels.spi

# Class AbstractSelectionKey

java.lang.Object
java.nio.channels.SelectionKey
java.nio.channels.spi.AbstractSelectionKey

public abstract class AbstractSelectionKey extends SelectionKey
Base implementation class for selection keys.

This class tracks the validity of the key and implements cancellation.

Since:
  1.4

## Field Summary

### Fields declared in class java.nio.channels.SelectionKey

`OP_ACCEPT, OP_CONNECT, OP_READ, OP_WRITE`

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`AbstractSelectionKey()`
Initializes a new instance of this class.

## Method Summary

Modifier and Type
Method
Description
`final void`
`cancel()`
Cancels this key.
`final boolean`
`isValid()`
Tells whether or not this key is valid.

### Methods declared in class java.nio.channels.SelectionKey

`attach, attachment, channel, interestOps, interestOps, interestOpsAnd, interestOpsOr, isAcceptable, isConnectable, isReadable, isWritable, readyOps, selector`

### Methods declared in class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### AbstractSelectionKey

protected AbstractSelectionKey()
Initializes a new instance of this class.

## Method Details

### isValid

public final boolean isValid()
Description copied from class: `SelectionKey`
Tells whether or not this key is valid.

A key is valid upon creation and remains so until it is cancelled, its channel is closed, or its selector is closed.

Specified by:
  `isValid` in class `SelectionKey`
Returns:
  `true` if, and only if, this key is valid

### cancel

public final void cancel()
Cancels this key.

If this key has not yet been cancelled then it is added to its selector's cancelled-key set while synchronized on that set.

Specified by:
  `cancel` in class `SelectionKey`